import type { Entrypoints, EntrypointsWebpackPlugin } from '@roots/entrypoints-webpack-plugin';
import type { Compilation } from 'webpack';
import Webpack from 'webpack';
export interface Options {
    emitWordPressJson: boolean;
    entrypointsPlugin?: typeof EntrypointsWebpackPlugin;
    exclude?: string[];
    outputPath?: string;
}
export default class WordPressDependenciesWebpackPlugin {
    options: Options;
    dependencies: Map<string, Set<string>>;
    outputPath: string;
    plugin: {
        name: string;
        stage: number;
    };
    requested: Map<string, Set<string>>;
    constructor(options?: Options);
    /**
     * Add item to set in map
     *
     * @remarks
     * Works for both our map of requests and our map of dependencies.
     */
    addItemToMap(obj: Map<string, Set<string>>, key: string, item: string): void;
    /**
     * Apply plugin
     */
    apply(compiler: Webpack.Compiler): void;
    extractDependenciesFromCompilation(compilation: Compilation): void;
    /**
     * Add mapped request to entrypoint manifest object
     */
    processChunkRequest(name: string, userRequest: string): void;
    /**
     * Tap entrypoints manifest object
     */
    tapEntrypointsManifestObject(entrypoints: Entrypoints): Entrypoints;
}
